---------------------------------------------------------------------------
NOTE1         :  vÖȉURL͏ĂgpB
uC:\Users\Documents\v
NOTE2         :  vÖȉ̃o[W͏ĂgpB
uR-3.1.1v
---------------------------------------------------------------------------;

*ȉ̃pXĂgp;
%let _path=C:/Users/Documents;
*;
%annomac;

data ds_a; length study $24;
input studyid study	qt	tt	qc	tc;
cards;
1	Blondal89	37	92	24	90
2	Campbell91	21	107	21	105
3	Fagerstrom82	30	50	23	50
4	Fee82	23	180	15	172
5	Garcia89	21	68	5	38
6	Garvey00	75	405	17	203
7	Gross95	37	131	6	46
8	Hall85	18	41	10	36
9	Hall87	30	71	14	68
10	Hall96	24	98	28	103
11	Hjalmarson84	31	106	16	100
12	Huber88	31	54	11	60
13	Jarvis82	22	58	9	58
14	Jensen91	90	211	28	82
15	Killen84	16	44	6	20
16	Killen90	129	600	112	617
17	Malcolm80	6	73	3	121
18	McGovern92	51	146	40	127
19	Nakamura90	13	30	5	30
20	Niaura94	5	84	4	89
21	Pirie92	75	206	50	211
22	Puska79	29	116	21	113
23	Schneider85	9	30	6	30
24	Tonnesen88	23	60	12	53
25	Villa99	11	21	10	26
26	Zelman92	23	58	18	58
;
run;

libname doc xport "C:\Users\Documents\WK2.xpt";
proc copy in=work out=doc;
  select ds_a / memtype=data;
run;

proc sql;
create table def as select distinct studyid,study from ds_a;
quit;

%macro onestate(state);
data ds; set ds_a;
d1=tt-qt;
d2=tc-qc;
if studyid<=&state.;
run;
proc transpose data=ds out=t;
  var qt d1 qc d2;
  by studyid;
run;
data tt; set t;
if _name_ in("qt","d1") then trt=1;
else trt=0;
if _name_ ^in("d1","d2") then ef=1;
else ef=0;
run;
proc freq data=tt noprint;
table trt*ef/all;
weight col1;
output out=or or n;
by studyid;
run;
data or; merge def or(in=in); by studyid; if in;run;

proc freq data=tt noprint;
table studyid*trt*ef/all;
weight col1;
output out=summary cmh;
run;
data summary; set summary;
studyid=28;
_RROR_=_MHOR_ ;
L_RROR=L_MHOR; 
U_RROR=U_MHOR;
keep studyid n _RROR_  L_RROR U_RROR;
run;
data or ; set or summary; 
if study="" then study="Summary";
drop studyid;
run;
data or; set or;
format studyid;
retain studyid 0;
studyid=studyid-1;
if _n_=1 then studyid=28;
if study="Summary" then studyid=1;
_n="("||trim(left(put(n,best.)))||")";
study2=trim(left(study))||" "||left(_n);
study=study2;
run;
libname doc xport "C:\Users\Documents\WK.xpt";
proc copy in=work out=doc;
  select or / memtype=data;
run;

*;

filename TEXT "C:\Users\Documents\TMP.R";
data _NULL_;
  file TEXT;
put "library(foreign);meta <- read.xport('&_path./WK.xpt');";
put "png('&_path./WRK.png');par(oma=c(0,8,0,0));";
put "plot(0, 0,type='n',xlim = c(0.3,16),ylim=c(0,28),xlab='',ylab='',yaxt='n',main='IbY95%M',log='x');";
put "segments(1,-1,1,29,col='#ff000090',lty=2);";
put "segments(meta$L_RROR,meta$STUDYID,meta$U_RROR,meta$STUDYID);";
put "mtext(meta$STUDY,side=2,line=3,at=(meta$STUDYID),las=1,cex=1);";
put "x1<-subset(meta,STUDYID>1);";
put "points(x1$X_RROR_, x1$STUDYID, col = '#0000ff90', pch = 16);";
put "x2<-subset(meta,STUDYID==1);";
put "points(x2$X_RROR_, x2$STUDYID, col = '#00ff0090', pch = 18,cex=2);";
put "dev.off()";
run;

options noxwait ;
X '"C:\Program Files\R\R-3.1.1\bin\R.exe" 
 --no-save < "C:\Users\Documents\TMP.R" > "C:\Users\Documents\TMP.log"';

data ANNO1;
  length function $8 style $ 32 ;
  retain xsys ysys '3' hsys '3' when 'a';
  function='move'; x=0; y=0; output; 
  function='image'; x=100; y=100; 
  imgpath="C:\Users\Documents\WRK.png"; style='fit'; output;
run;
data ANNO; set ANNO1 ; when="a"; run;
proc ganno anno=ANNO;
run;
%mend;

data usa;
  do state=1 to 26;output;end;
run;

data _null_;
   set usa end=done;
   file 'C:\Users\Documents\plot.sas';
   if _n_ = 1
   then put "filename animmap 'C:\Users\Documents\}8_Odds.gif';" /
            "goptions reset=goptions  device=gifanim gsfmode=replace gsfname=animmap "
            "cback=white iteration=0 delay=200 disposal=background noborder htitle=13pt xmax=5in ymax=5in;";
   else if _n_ = 2
   then put "goptions gsfmode=append delay=200;";
   if done then put "goptions gepilog='3B'x delay=500;";
   put '%onestate(' state ');';
run;

%inc 'C:\Users\Documents\plot.sas';





